'From Cuis 2.9 of 5 November 2010 [latest update: #634] on 18 November 2010 at 8:54:49 am'!

!Browser methodsFor: 'class functions' stamp: 'cbr 11/15/2010 19:44'!
buildMorphicSwitches
	| instanceSwitch commentSwitch classSwitch row aColor |
	instanceSwitch := PluggableButtonMorph 
				model: self
				stateGetter: #instanceMessagesIndicated
				action: #indicateInstanceMessages.
	instanceSwitch
		label: 'instance';
		askBeforeChanging: true;
		borderWidth: 0.
	commentSwitch := PluggableButtonMorph 
				model: self
				stateGetter: #classCommentIndicated
				action: #plusButtonHit.
	commentSwitch
		label: '?' asText allBold;
		askBeforeChanging: true;
		setBalloonText: 'class comment';
		borderWidth: 0.
	classSwitch := PluggableButtonMorph 
				model: self
				stateGetter: #classMessagesIndicated
				action: #indicateClassMessages.
	classSwitch
		label: 'class';
		askBeforeChanging: true;
		borderWidth: 0.
	row _ AlignmentMorph proportional.
	row
		addMorph: instanceSwitch fullFrame: (LayoutFrame fractions: (0@0 corner: 0.5@1));
		addMorph: commentSwitch fullFrame: (LayoutFrame fractions: (0.51@0 corner: 0.65@1));
		addMorph: classSwitch fullFrame: (LayoutFrame fractions: (0.66@0 corner: 1@1)).
	aColor := Color colorFrom: self class windowColor.
	row color: aColor duller.	"ensure matching button divider color. (see #paneColor)"
	aColor := aColor muchLighter.
	{ 
		instanceSwitch.
		commentSwitch.
		classSwitch} do: [:m | 
				m
					color: aColor;
					onColor: ColorTheme current switchOn
					offColor: ColorTheme current switchOff].
	^row! !

!Browser methodsFor: 'initialize-release' stamp: 'cbr 11/7/2010 22:37'!
buildMorphicSystemCatList
	| dragNDropFlag myCatList |
	dragNDropFlag := false.
	(myCatList := PluggableListMorph new)
		model: self
		listGetter: #systemCategoryList
		indexGetter: #systemCategoryListIndex
		indexSetter: #systemCategoryListIndex:
		menuGetter: #systemCategoryMenu:
		keystrokeAction: #systemCatListKey:from:.
	myCatList enableDragNDrop: dragNDropFlag.
	^myCatList! !

!Browser methodsFor: 'initialize-release' stamp: 'cbr 11/13/2010 10:51'!
openAsMorphEditing: editString
	"Create a pluggable version of all the morphs for a Browser in Morphic"
	| window hSepFrac |

	hSepFrac _ 0.4.
	window _ SystemWindow new model: self.
	
"The method SystemWindow>>addMorph:fullFrame: checks scrollBarsOnRight, then adds the morph at the back if true, otherwise it is added in front. But flopout hScrollbars need the lowerpanes to be behind the upper ones in the draw order. Hence the value of scrollBarsOnRight affects the order in which the lowerpanes are added. "
	Preferences scrollBarsOnRight ifFalse: [
		self 
			addLowerPanesTo: window 
			at: (0@hSepFrac corner: 1@1) 
			with: editString].
		
	window 
		addMorph: self buildMorphicSystemCatList
		frame: (0@0 corner: 0.25@hSepFrac).

	self 
		addClassAndSwitchesTo: window 
		at: (0.25@0 corner: 0.5@hSepFrac)
		plus: 0.
	window 
		addMorph: self buildMorphicMessageCatList
		frame: (0.5@0 extent: 0.25@hSepFrac).
	window addMorph: self buildMorphicMessageList
		frame: (0.75@0 extent: 0.25@hSepFrac).
		
	Preferences scrollBarsOnRight ifTrue: [
		self 
			addLowerPanesTo: window 
			at: (0@hSepFrac corner: 1@1) 
			with: editString].
		
	window setUpdatablePanesFrom: #(systemCategoryList classList messageCategoryList messageList).
	^ window! !


!DualChangeSorter class methodsFor: 'window color' stamp: 'cbr 11/15/2010 19:44'!
windowColor
	^ ColorTheme current dualChangeSorter! !


!LazyListMorph methodsFor: 'drawing' stamp: 'cbr 11/15/2010 19:46'!
colorForRow: 	row
	^(selectedRow notNil and: [ row = selectedRow])
		ifTrue: [ ColorTheme current listRow ]
		ifFalse: [ self color ].! !

!LazyListMorph methodsFor: 'drawing' stamp: 'cbr 11/15/2010 19:46'!
drawSelectionOn: aCanvas
	| selectionDrawBounds |
	selectedRow ifNil: [ ^self ].
	selectedRow = 0 ifTrue: [ ^self ].
	selectionDrawBounds := self drawBoundsForRow: selectedRow.
	selectionDrawBounds := selectionDrawBounds intersect: bounds.
	aCanvas fillRectangle: selectionDrawBounds color: (
		Display depth = 1 
			ifTrue: [Color lightGray] 
			ifFalse: [
				Display depth = 2 
					ifTrue: [Color black] 
					ifFalse: [ColorTheme current listHighlight]])! !


!ListItemWrapper methodsFor: 'as yet unclassified' stamp: 'cbr 11/15/2010 19:45'!
highlightingColor

	^ ColorTheme current text! !


!ListLW methodsFor: 'initialization' stamp: 'cbr 11/15/2010 19:45'!
initialize
	super initialize.
	backColor _ ColorTheme current listHighlight.
	scrollBarColor _ backColor darker.
	scrollThumbColor _ scrollBarColor darker! !


!MinimalStringMorph methodsFor: 'initialization' stamp: 'cbr 11/15/2010 19:46'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ ColorTheme current text! !


!OneLineEditorMorph methodsFor: 'initialization' stamp: 'cbr 11/15/2010 19:46'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ ColorTheme current text! !


!PluggableButtonMorph methodsFor: 'drawing' stamp: 'cbr 11/15/2010 19:46'!
drawOn: aCanvas 

	| w f center x y |
	super drawOn: aCanvas.
	f _ self fontToUse.
	center _ bounds center.

	label ifNotNil: [
		w _ f widthOfString: label.
		x _ bounds width > w
			ifTrue: [ center x - (w // 2) ]
			ifFalse: [ bounds left +4].
		y _ center y - (f height // 2).
		aCanvas drawString: label at: x@y font: f color: ColorTheme current label ].

	showSelectionFeedback ifTrue: [
		aCanvas frameRectangle: self innerBounds width: 2 color: feedbackColor].! !

!PluggableButtonMorph methodsFor: 'initialization' stamp: 'cbr 11/15/2010 19:46'!
initialize
	"initialize the state of the receiver"
	super initialize.

	model _ nil.
	getStateSelector _ nil.
	actionSelector _ nil.
	getLabelSelector _ nil.
	getMenuSelector _ nil.
	shortcutCharacter _ nil.
	askBeforeChanging _ false.
	triggerOnMouseDown _ false.
	onColor _ ColorTheme current buttonOn.
	offColor _ ColorTheme current buttonOff.
	feedbackColor _ Color red.
	showSelectionFeedback _ false.
	allButtons _ nil.
	argumentsProvider _ nil.
	argumentsSelector _ nil.
	self extent: 20 @ 15! !


!PluggableListMorph methodsFor: 'initialization' stamp: 'cbr 11/15/2010 19:57'!
model: anObject listGetter: getListSel indexGetter: getSelectionSel indexSetter: setSelectionSel menuGetter: getMenuSel keystrokeAction: keyActionSel

	self model: anObject.
	getListSelector _ getListSel.
	getIndexSelector _ getSelectionSel.
	setIndexSelector _ setSelectionSel.
	getMenuSelector _ getMenuSel.
	keystrokeActionSelector _ keyActionSel.
	autoDeselect _ true.
	self 
		borderWidth: 1;
		updateList;
		selectionIndex: self getCurrentSelectionIndex;
		initForKeystrokes
! !

!PluggableListMorph methodsFor: 'initialization' stamp: 'cbr 11/15/2010 19:46'!
textColor
	""
	^ ColorTheme current text! !


!Preferences class methodsFor: 'menu parameters' stamp: 'cbr 11/15/2010 19:45'!
restoreDefaultMenuParameters
	"Restore the four color choices of the original implementors of  
	MorphicMenus"
	" 
	Preferences restoreDefaultMenuParameters
	"
	Parameters
	
		at: #menuColor
		put: ColorTheme current menu;
		
		at: #menuBorderWidth
		put: 2;
	
		at: #menuTitleColor
		put: ColorTheme current menuTitleBar;
	
		at: #menuTitleBorderWidth
		put: 1! !

!Preferences class methodsFor: 'standard queries' stamp: 'cbr 11/15/2010 19:45'!
focusIndicatorColor
	^ self
		valueOfFlag: #focusIndicatorColor
		ifAbsent: [ColorTheme current focusIndicator]! !

!Preferences class methodsFor: 'text highlighting' stamp: 'cbr 11/15/2010 19:45'!
initializeTextHighlightingParameters
	"
	Preferences initializeTextHighlightingParameters
	"
	Parameters

		at: #insertionPointColor
		put: ColorTheme current insertionPoint;

		at: #textHighlightColor
		put: ColorTheme current textHighlight.! !


!SHTextStylerST80 class methodsFor: 'style table' stamp: 'cbr 11/15/2010 19:45'!
defaultStyleTable
	^ ColorTheme current shout! !


!SimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'cbr 11/15/2010 19:46'!
lineColor
	"One line color for the whole system."
	
	lineColor ifNotNil: [ ^lineColor ].
	^ ColorTheme current line! !

!SimpleHierarchicalListMorph methodsFor: 'drawing' stamp: 'cbr 11/15/2010 19:46'!
drawOn: aCanvas

	super drawOn: aCanvas.

	(drawKeyboardFocusIndicator and: [ self hasKeyboardFocus ]) ifTrue: [
		aCanvas
			frameRectangle: self focusIndicatorRectangle 
			width: Preferences focusIndicatorWidth
			color: Preferences focusIndicatorColor ].

	selectedMorph  ifNotNil:
		[aCanvas fillRectangle:
			((selectedMorph bounds: selectedMorph bounds in: self)
						intersect: scroller bounds)
				color: ColorTheme current listHighlight].

	Preferences showLinesInHierarchyViews ifTrue:[
		self drawLinesOn: aCanvas.
	].


! !


!StringHolder class methodsFor: 'window color' stamp: 'cbr 11/15/2010 19:44'!
windowColor
	^ ColorTheme current workspace! !


!Browser class methodsFor: 'window color' stamp: 'cbr 11/15/2010 19:44'!
windowColor
	^ ColorTheme current browser! !


!ChangeSorter class methodsFor: 'window color' stamp: 'cbr 11/15/2010 19:44'!
windowColor
	^ ColorTheme current changeSorter! !


!FileList class methodsFor: 'window color' stamp: 'cbr 11/15/2010 19:44'!
windowColor
	^ ColorTheme current fileList! !


!PackagePaneBrowser class methodsFor: 'window color' stamp: 'cbr 11/15/2010 19:44'!
windowColor
	^ ColorTheme current packageBrowser! !


!StringMorph methodsFor: 'initialization' stamp: 'cbr 11/15/2010 19:45'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ ColorTheme current menuText! !


!MenuItemMorph methodsFor: 'drawing' stamp: 'cbr 11/15/2010 19:46'!
drawOn: aCanvas 
	| stringColor stringBounds leftEdge |

	stringColor := color.
	isSelected & isEnabled
		ifTrue: [
			aCanvas fillRectangle: bounds color: (
				Display depth < 8
					ifTrue: [ Color veryLightGray ]
					ifFalse: [ ColorTheme current menuHighlight ])].
	leftEdge := 0.
	self hasIcon
		ifTrue: [| iconForm | 
			iconForm := isEnabled ifTrue:[self icon] ifFalse:[self icon asGrayScale].
			aCanvas paintImage: iconForm at: self left @ (self top + (self height - iconForm height // 2)).
			leftEdge := iconForm width + 2].

	self hasMarker
		ifTrue: [ leftEdge := leftEdge + self submorphBounds width + 8 ].

	stringBounds := bounds left: bounds left + leftEdge.

	aCanvas
		drawString: contents
		in: stringBounds
		font: self fontToUse
		color: stringColor.
	subMenu
		ifNotNil: [aCanvas paintImage: SubMenuMarker at: self right - 8 @ (self top + self bottom - SubMenuMarker height // 2)]! !


!SystemWindow methodsFor: 'drawing' stamp: 'cbr 11/15/2010 19:46'!
drawOn: aCanvas

	| titleColor |
	super drawOn: aCanvas.

	titleColor _ self isTopWindow
		ifTrue: [ self paneColorToUse paler ]
		ifFalse: [ self paneColorToUse ].

	aCanvas
		frameAndFillRectangle: self titleAreaRect
		fillColor: titleColor
		borderWidth: borderWidth
		borderColor: titleColor.

	aCanvas
		drawString: labelString
		in: self labelRectangle
		font: Preferences windowTitleFont
		color: ColorTheme current label! !

!SystemWindow methodsFor: 'initialization' stamp: 'cbr 11/4/2010 13:21'!
createBox
	"create a button with default to be used in the label area"

	| box |
	box := IconicButton new.
	box
		color: Color transparent;
		borderNormal;
		target: self.
		
	^box! !

!SystemWindow methodsFor: 'initialization' stamp: 'cbr 11/7/2010 18:58'!
defaultColor
	"answer the default color/fill style for the receiver"
	^ Color white! !

!SystemWindow methodsFor: 'initialization' stamp: 'cbr 11/15/2010 20:06'!
initialize
	"Initialize a system window. Add label, stripes, etc., if desired"
	super initialize.
	labelString ifNil: [labelString := 'Untitled Window' translated].
	isCollapsed := false.
	paneMorphs := Array new.
	borderColor := #raised.
	borderWidth := 2.
	
	self wantsLabel ifTrue: [self initializeLabelArea].
	self 
		on: #mouseEnter
		send: #spawnReframeHandle:
		to: self.
	self 
		on: #mouseLeave
		send: #spawnReframeHandle:
		to: self.
	self extent: 300 @ 200.
	updatablePanes := Array new! !

!SystemWindow methodsFor: 'initialization' stamp: 'cbr 11/4/2010 14:48'!
initializeLabelArea
	"Initialize the label area (titlebar) for the window."

	| spacing |
	spacing _ self boxExtent x + 2.

	self
		addMorph: (self createCloseBox position: 2@2);
		addMorph: (self createCollapseBox position: spacing+2@2);
		addMorph: (self createExpandBox position: spacing*2+2@2);
		addMorph: (self createMenuBox position: spacing*3+2@2)! !

!SystemWindow methodsFor: 'panes' stamp: 'cbr 11/15/2010 20:07'!
paneColor
	
	| cc |
	(cc := paneColor) ifNotNil: [^cc].
	Display depth > 2 
		ifTrue: [
			model ifNotNil: [
					model isInMemory 
						ifTrue: [
							cc := self windowColor.]].
			cc ifNil: [cc := paneMorphs isEmptyOrNil ifFalse: [paneMorphs first color]]].
	cc ifNil: [cc := Color white].
	self paneColor: cc.
	^cc
! !

!SystemWindow methodsFor: 'panes' stamp: 'cbr 11/15/2010 19:46'!
paneColor: aColor
	paneColor _ aColor.
	aColor
		ifNotNil: [ ColorTheme current paneExperiment value: self value: aColor ].
	self adoptPaneColor: aColor.! !

!SystemWindow methodsFor: 'panes' stamp: 'cbr 11/14/2010 01:11'!
windowColor
	^ Color colorFrom: model class windowColor duller! !


!SystemWindow class methodsFor: 'accessing - icons' stamp: 'cbr 11/4/2010 11:21'!
closeIcon
	"Supplied here because we don't necessarily have ComicBold"

	CloseIcon ifNil: [
		CloseIcon := (Form
			extent: 14@14
			depth: 32
			fromArray: #(0 0 6032910 288687365 1550655006 2844865845 3450028610 3450028610 2828088372 1550655006 288687365 5967374 0 0 1377027 15091784 844830230 3063889984 4158092147 4294153621 4294681250 4294681250 4294153364 4158091376 3047046718 844764694 14763847 1376770 7742243 861541910 3585164870 4294282123 4294943908 4294943908 4294943651 4294943651 4294943908 4294943908 4294216330 3585099848 844764694 7676450 288098055 3047109684 4294211447 4294939539 4293757578 4293363848 4294939025 4294939282 4293954186 4293560456 4294939539 4294212732 3047110455 288031748 1584209695 4158081610 4294932343 4293753466 4291733929 4291802549 4293164156 4293884281 4291666594 4291670192 4293294457 4294933885 4158018130 1567432222 2861706541 4294136145 4294924376 4292761945 4292198592 4294704894 4292064950 4291403679 4294375158 4293057499 4291846497 4294925147 4294136659 2844863789 3483644980 4294660947 4294923605 4294857555 4292566879 4292658886 4294770173 4294704380 4293452000 4291981681 4294595154 4294923605 4294660947 3466867764 3500422196 4294726483 4294923605 4294923605 4293742415 4291402908 4294836223 4294967295 4292198592 4292760660 4294923348 4294923605 4294660947 3483644980 2878484014 4294136145 4294923605 4293939794 4291728018 4294375158 4293452257 4292793042 4294704637 4292128944 4293154390 4294923605 4294136145 2878484014 1617830177 4174923591 4294923862 4292957011 4292000442 4293386721 4291915888 4292238685 4292659400 4292595406 4292303450 4294923605 4158146375 1617829920 305072650 3097572147 4294267217 4294923348 4292631901 4291781989 4294595154 4294857555 4292435036 4292238942 4294857812 4294267217 3097506611 305007114 8070437 912005658 3635624249 4294333010 4294923605 4294857555 4294923605 4294923605 4294923348 4294923348 4294333010 3635624249 895228442 8004901 1639428 16735838 912071451 3131126579 4191766343 4294267217 4294726740 4294726740 4294201681 4191766343 3131126579 895293978 16735067 1573892 0 0 6888733 322506254 1651515681 2945723950 3550885173 3550885173 2945723950 1651515681 322440718 6822940 0 0)
			offset: 0@0)].
	^CloseIcon! !

!SystemWindow class methodsFor: 'accessing - icons' stamp: 'cbr 11/4/2010 11:31'!
collapseIcon
	"Supplied here because we don't necessarily have ComicBold"

	CollapseIcon ifNil: [
		CollapseIcon := (Form
			extent: 14@14
			depth: 32
			fromArray:  #(0 768 5853184 288569344 1550537988 2844748052 3449976096 3449976096 2827970835 1550537731 288569600 5787392 768 0 1256960 15043082 844713216 3063837470 4158037328 4294162549 4294689156 4294689156 4294162292 4158036813 3046994460 844713216 14714890 1256704 7690756 861424896 3585112609 4294226279 4294952069 4294952069 4294951812 4294951812 4294952069 4294952068 4294226278 3585047331 844647680 7625220 287914752 3047058190 4294222924 4294949230 4294948716 4294948716 4294948716 4294948716 4294948716 4294948717 4294949231 4294223955 3047058707 287914240 1584092675 4158030361 4294944327 4294945619 4294945877 4294946134 4294946134 4294945877 4294945619 4294945102 4294944587 4294945360 4158031652 1567315202 2861589770 4294150937 4294938911 4294217252 4293955628 4294021937 4294021938 4294021421 4294020390 4293954079 4294084893 4294873892 4294151196 2844812298 3483593741 4294741530 4294478360 4291271017 4292461743 4292461485 4292461485 4292461485 4292461485 4292527535 4291340680 4293625630 4294807066 3466816525 3500370957 4294741530 4294347032 4291669904 4294112759 4294112244 4294112244 4294112244 4294112244 4294243831 4292200893 4293428769 4294807066 3483593741 2878432779 4294150937 4294806810 4292511536 4292382532 4292382531 4292382531 4292382531 4292382531 4292382532 4292249912 4294347548 4294216473 2878432523 1617712902 4174872597 4294938651 4294938393 4294938136 4294938136 4294938136 4294938136 4294938136 4294938136 4294938393 4294938651 4158095381 1617712902 304955136 3097520909 4294282265 4294938395 4294938395 4294938395 4294938395 4294938395 4294938395 4294938395 4294938395 4294282009 3097455373 304889600 7953671 911888388 3635573264 4294347801 4294938651 4294938395 4294938395 4294938395 4294938395 4294938651 4294347801 3635573264 895111172 7888135 1520128 16753431 911954180 3131075341 4191781141 4294216473 4294741530 4294741530 4294216473 4191781141 3131075341 895176964 16752406 1454592 0 3072 6708483 322388481 1651398919 2945607436 3550833934 3550833934 2945607436 1651398919 322322945 6642947 2816 0)
			offset: 0@0)].
	"CollapseIcon := (CollapseIcon asFormOfDepth: 32) fixAlpha."
	^CollapseIcon! !

!SystemWindow class methodsFor: 'accessing - icons' stamp: 'cbr 11/4/2010 11:41'!
expandIcon
	ExpandIcon ifNil: [
		ExpandIcon := (Form
			extent: 14@14
			depth: 32
			fromArray:  #(0 0 1058562 285544960 1545616142 2838976800 3443812652 3443812652 2822199328 1545550349 285610496 1058562 0 0 197889 5015843 840445449 3057804586 4151680347 4288134782 4288989580 4288989580 4288134525 4151549016 3040961576 840379656 4949796 132352 2441745 857222409 3578360366 4287543665 4289187213 4289121422 4288857993 4288792456 4289121421 4289121677 4287478128 3578491696 840445193 2375953 285740802 3040304923 4286295641 4288070777 4288004983 4287543410 4288524177 4289312671 4287344755 4288004983 4288136313 4286624095 3040502048 285543680 1579236111 4149118761 4286297173 4286822495 4286888545 4286426462 4291679432 4293717227 4286752873 4286560090 4286428504 4286691421 4149578546 1562393102 2855294231 4283865130 4284326448 4284325172 4284718907 4284716865 4291416516 4293651691 4285043786 4284061998 4283996461 4284523316 4283996461 2838517015 3476513307 4284063275 4283865386 4287341947 4290759608 4290693559 4293717483 4294572537 4291153599 4290759607 4288129929 4283864876 4283997739 3459736090 3493290523 4284063275 4283799593 4289312927 4294243316 4294046193 4294769916 4294901502 4294177779 4294243316 4290364338 4283864621 4284063275 3476513306 2872071703 4283865130 4284063275 4284453693 4285176395 4285109069 4291811019 4293849070 4285962336 4285110602 4284585024 4283997227 4283799593 2872071447 1612856592 4165698852 4284195372 4284063786 4284064041 4283864620 4291285440 4293651690 4284782402 4283998248 4284063786 4284195372 4148921636 1612856336 302649860 3090571034 4283865642 4284129580 4284129580 4283930157 4289378465 4291218626 4284519486 4284064042 4284129580 4283865642 3090505498 302649604 2573587 907751437 3627904029 4283865642 4284195372 4284063275 4284060978 4284126260 4283996972 4284195372 4283865642 3627838237 890974221 2573330 263937 6533168 907817229 3124125722 4182476324 4283865386 4284063531 4284063531 4283865386 4182476324 3124125722 891040013 6335279 263937 0 0 1979406 319691015 1646476817 2939246103 3543687963 3543687963 2939246103 1646476817 319691015 1979406 0 0)
			offset: 0@0)].
	"ExpandIcon := (ExpandIcon asFormOfDepth: 32) fixAlpha."
	^ExpandIcon! !

!SystemWindow class methodsFor: 'accessing - icons' stamp: 'cbr 11/4/2010 11:48'!
menuIcon
	MenuIcon ifNil: [
		MenuIcon := (Form
			extent: 14@14
			depth: 32
			fromArray:  #(0 0 7774 285216318 1544039783 2837267842 3442168720 3442168720 2820490625 1544039782 285216574 7774 0 0 2087 1532860 839001178 3056161165 4150166716 4286817494 4287738079 4287803615 4286751958 4150035131 3039252364 839001178 1467065 1831 668526 855712858 3576584601 4286029012 4287935459 4287935458 4287869666 4287869666 4287935458 4287869923 4285963476 3576715929 838935642 602733 285216827 3038463881 4284517582 4286621149 4286489564 4286489564 4286489564 4286489564 4286489564 4286489820 4286621149 4284911823 3038726794 285216058 1577594471 4147012271 4284387029 4284978391 4285043927 4285109719 4285109719 4285044183 4284978135 4284649685 4284518357 4284912599 4147603633 1560751463 2853453696 4281560257 4281888189 4283200687 4284186808 4284515256 4284515257 4284252600 4283858102 4283529653 4282740653 4282151359 4281757378 2836676480 3474606220 4281757894 4281559740 4285761703 4292993507 4293454315 4293388522 4293388522 4293454315 4292862177 4285432998 4281494205 4281692102 3457829004 3491383436 4281757638 4281758153 4281953722 4288589251 4294835708 4294967295 4294967295 4294769659 4288194752 4281887931 4281823689 4281692102 3474606220 2870296704 4281560257 4281823689 4281758153 4282215861 4289838026 4294967294 4294967038 4289377991 4282084534 4281758153 4281823689 4281560257 2870296704 1611280232 4163592111 4281823946 4281823688 4281692360 4282740914 4291152852 4290758353 4282544051 4281692361 4281823688 4281823946 4146749358 1611214696 301994814 3088664202 4281626050 4281823689 4281823688 4281692103 4282937773 4282806447 4281692360 4281823688 4281823689 4281626050 3088664202 301994814 734577 906307420 3625930390 4281626050 4281823946 4281823689 4281692360 4281692360 4281823689 4281823946 4281626050 3625930390 889530204 734576 2347 2392036 906373213 3122218634 4180369583 4281560257 4281757638 4281757638 4281560257 4180369583 3122218634 889595997 2325471 2346 0 3 76907 318773060 1644834921 2937405569 3541780621 3541780621 2937405569 1644834921 318773059 76906 2 0)
			offset: 0@0)].
	"MenuIcon := (MenuIcon asFormOfDepth: 32) fixAlpha."
	^MenuIcon! !


!TestRunner class methodsFor: 'instance creation' stamp: 'cbr 11/15/2010 19:44'!
windowColor
	^ ColorTheme current testRunner! !


!TextMorph methodsFor: 'initialization' stamp: 'cbr 11/15/2010 19:46'!
defaultColor
	"Return the default fill style for the receiver"
	^ ColorTheme current text! !


!TranscriptStream class methodsFor: 'window color' stamp: 'cbr 11/15/2010 19:44'!
windowColor
	^ ColorTheme current transcript! !

"Postscript:

Script to initialize CaseyCuisChanges"

Preferences initializeTextHighlightingParameters.
SystemWindow recreateBoxes.!

