'From Cuis 2.9 of 5 November 2010 [latest update: #634] on 25 November 2010 at 3:48:52 pm'!

!CharacterScanner commentStamp: '<historical>' prior: 0!
My instances hold the state associated with scanning text. My subclasses scan characters for specified purposes, such as computing a CharacterBlock or placing characters into Forms.

My instances are usually transient, lasting only during the scanning operation, and therefore don't need a TextHolder, but just a Text with the current contents.!


!TextComposer commentStamp: '<historical>' prior: 0!
Aux class for NewParagraph. My instances are usually transient, and therefore don't need a TextHolder, but just a Text with the current contents.!


!Morph methodsFor: 'menus' stamp: 'jmv 11/25/2010 10:25'!
addCopyItemsTo: aMenu 
	"Add copy-like items to the halo menu"

	| subMenu |
	subMenu := MenuMorph new defaultTarget: self.
	subMenu add: 'copy to paste buffer' translated action: #copyToPasteBuffer:.
	aMenu add: 'copy & print...' translated subMenu: subMenu! !

!Morph methodsFor: 'meta-actions' stamp: 'jmv 11/25/2010 10:25'!
buildMetaMenu: evt 
	"Build the morph menu. This menu has two sections. The first section contains commands that are handled by the hand; the second contains commands handled by the argument morph."

	| menu |
	menu := MenuMorph new defaultTarget: self.
	menu addStayUpIcons.
	menu add: 'grab' translated action: #grabMorph:.
	menu add: 'copy to paste buffer' translated action: #copyToPasteBuffer:.
	self maybeAddCollapseItemTo: menu.
	menu add: 'delete' translated action: #dismissMorph:.
	menu addLine.
	menu add: 'go behind' translated action: #goBehind.
	menu add: 'add halo' translated action: #addHalo:.
	menu add: 'duplicate' translated action: #maybeDuplicateMorph:.
	self addEmbeddingMenuItemsTo: menu hand: evt hand.
	menu add: 'resize' translated action: #resizeMorph:.
	"Give the argument control over what should be done about fill styles"
	self addFillStyleMenuItems: menu hand: evt hand.
	menu 
		addUpdating: #hasClipSubmorphsString
		target: self
		selector: #changeClipSubmorphs
		argumentList: #().
	menu addLine.
	(self morphsAt: evt position) size > 1 
		ifTrue: 
			[menu 
				add: 'submorphs...' translated
				target: self
				selector: #invokeMetaMenuAt:event:
				argument: evt position].
	menu addLine.
	menu 
		add: 'inspect' translated
		selector: #inspectAt:event:
		argument: evt position.
	menu add: 'explore' translated action: #explore.
	menu add: 'browse hierarchy' translated action: #browseHierarchy.
	menu add: 'show actions' translated action: #showActions.
	menu addLine.
	self addDebuggingItemsTo: menu hand: evt hand.
	self addCustomMenuItems: menu hand: evt hand.
	^menu! !

TextMorph removeSelector: #userString!
IndentingListItemMorph removeSelector: #userString!
StringMorph removeSelector: #userString!
Morph removeSelector: #allStringsAfter:!
Morph removeSelector: #clipText!
Morph removeSelector: #userString!
